#! /usr/local/bin/perl
#
# this script is a multi purpose script to generate all the data files
# needed for virtual hosting email via sendmail.  The files generated
# are:
#forward aliases
# reverse aliases
# domain class
# (maybe) sendmail.cw
# 
# the original file for virtual domain email addresses contains all
# the information necessary to create all of the other files but it
# just needs a bit of rearranging to make it visible.

#customize these file names to fit your local circumstances.
$domain_table = "./domain_table";
$reverse_table = "./reverse_aliases";
$virtual_table = "./forward_aliases";

#dbmopen(%addresses, $virtual_table, 0664) || die "Error: $!\n";

#main entry point #
# usage: data.pl < address table
#

while (<STDIN>) {
    chop;
    if (!/^\#/) {		# if not a comment
	($virtual_address, $real_address) = split;
	if ( $addresses{$virtual_address} eq "") {
	    #non duplicate address, stuff into array
	    $addresses{$virtual_address} = $real_address;

	    # If reverse addresses are duplicated, use only the
	    # first one and warn about discarding the others.
	    # reverse addresses can be duplicated because a single
	    # recipient can have multiple aliases.
	    if ( $reverse_addresses{$real_address} eq "") {
		$reverse_addresses{$real_address} = $virtual_address;
	    }
	    else {
		print STDERR "duplicate reverse address for $real_address\n";
	    }
            #if address contains an @, strip out domain and add to
	    #virtual domain list
	    if ($virtual_address =~/@/) {
		($user, $domain) = split (/@/,$virtual_address) ;
		 # it doesn't matter if we overwrite duplicate
		 # domains.  In fact I expect duplicate domains and
		 # this is an  easy way to eliminate duplicates.
		$virtual_domain{$domain} = $user;
	    }
	}
	else {
	    print STDERR "duplicate address: $virtual_address: $real_address\n";
	}
    }
}

# write the domain table.
open (handle, ">$domain_table") || die "unable to open $domain_table";
while (($key, $value) = each %virtual_domain) {
    print handle "$key\n";
}
close handle;

#  Write the virtual address table
open (handle, ">$virtual_table") || die "unable to open $virtual_table";
while (($key, $value) = each %addresses) {
    print handle "$key\t$value\n";
}
close handle;

#dbmclose(%addresses);

### #write the reverse address table
### open (handle, ">$reverse_table") || die "unable to open $reverse_table";
### while (($key, $value) = each %reverse_addresses) {
###     print handle "$key\t$value\n";
### }
### close handle;




